\section{Coding}
This chapter contains tipps and tricks from Robert, which we may won't agree on. He is just explaining the habits he has evolved over the years to write good code.

\subsection{Preparedness}
Coding requires a high level of concentration and is intellectually challenging. Therefore make sure to only write code when you are feeling well and fit.

\paragraph{3 AM Code}
There is a simple and easy rule: don't write code, when you are tired!

\paragraph{Worry Code}
Be sure to start working on code when your mind is free. If you have other influences on your mind which you worry about, sort them out first. For sure you can't solve every problem in a 30 minute break, but it makes yourself feel more comfortable to start coding again. 

\subsection{The Flow Zone}
Every programmer knows about the Zone. But please try to avoid it while writing code. If you are practicing it's okay to flow into the zone. The Zone does for sure speed up your work but it will also linder your quality.

\paragraph{Music}
Some programmers do work better with music, but most of them just go into the zone quicker with the help of music. Make sure you know if you need music to program efficiently or not.

\paragraph{Interruptions}
You are and will be interrupted while coding, but there are several techniques to get back to work quicker. This could be pair programming or also TDD.

\subsection{Writer Block}
It will happen to the best of us, sometimes you are just blocked to write new code. Also here are several solutions possible: team up for pair programming.

\paragraph{Creative Input}
Creative output depends on creative input. Therefore if you find yourself in a blockade, you could try to get some suiting creative input for yourself. This could be reading a book, listening to music.

\subsection{Debugging}
Debugging is essential in the early stage of a developer. But also debugging time has to be spend in order to reach a product with overall good quality. Make sure you minimise the debugging time spent over the years - because you are a professional.

\subsection{Pacing Yourself}
Software development is not a sprint, it is a marathon! Make sure to take care of your body, energy, creativity before and during your programming sessions.

\paragraph{Know When to Walk Away}
You find yourself spending hours over hours in a bug or an issue in your code and you can't leave before the issue is solved? When you are stuck try to disengage for a while. There are different forms of disengagements and this depends on the person: driving the car home, taking a shower, doing sports.

\subsection{Being Late}
Everybody will be late sometime, because we miss-judged events or even failed our time planning. Always find three estimates for your task: best case, nominal case, worst case.

\paragraph{Hope}
Don't let hope influence the time estimation on your tasks. If you see your worst case is longer than the current sprint, inform the team as soon as possible! Hope is a project killer.

\paragraph{Rushing} 
Do not be temped to rush! If you try to take shortcuts or rush to meet your goals, you have used the receipt for disaster! There is no way you can make yourself to code faster.


\paragraph{Overtime}
You should only agree to overtime when: you can personally afford it, it is short term, your boss has a fall-back plan in case the overtime options does fail. The last one is a deal breaker!

\paragraph{False Delivery}
Make sure the team has a clear understanding of what done means. Otherwise there are developers which think the code on their machine is counted as done, even when no integration tests or unit test are run.

\subsection{Help}
Programming is hard! Therefore you can always benefit from other developers. Not because they are smarter or better, they bring in another angle of view.

\paragraph{Helping Other}
Make yourself clear time slots as a senior when you want to help juniors or other developers when questions arise. For sure if you see someone in hard trouble help them, but you must also keep yourself focused on your work.

\paragraph{Being Helped}
Do always welcome feedback, try no to protect your turf. Good programmers need to collaborate with each other on order to create good software.

\paragraph{Mentoring}
The best way to bring a junior up to his potential is with mentoring.



